package markov.huffman;

import com.tomgibara.bits.Bits;
import directory.passive.huffman.ByteHuffmanCodeBuilder;
import directory.passive.huffman.HuffmanCode;
import markov.stuff.SimpleCountMap;
import markov.stuff.Utils;
import org.junit.jupiter.api.Test;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Base64;
import java.util.List;

class ByteHuffmanCodeBuilderTest {

    @Test
    void testByteHuffman() {
        SimpleCountMap<Integer> countMap = new SimpleCountMap<>();
        for (int i = 0; i < 8; i++) {
            for (int j = 0; j < i; j++) {
                countMap.count(i);
            }
        }
        HuffmanCode<Integer, List<Boolean>> code =
                ByteHuffmanCodeBuilder.<Integer, SimpleCountMap.MutableInt>createFactory()
                        .generateCode(countMap,
                        new SimpleCountMap.MutableInt.FrequencySupport());
        List<Boolean> result = new ArrayList<>();
        result.addAll(encoded(code, 6));
        result.addAll(encoded(code, 2));
        result.addAll(encoded(code, 1));
        result.addAll(encoded(code, 7));
        result.addAll(encoded(code, 4));
        System.out.println(result);
        byte[] byteArray = Bits.asStore(Utils.fromBitList(result)).toByteArray();
        System.out.println(Arrays.toString(byteArray));
        String b64 = Base64.getEncoder().encodeToString(byteArray);
        System.out.println(b64);
        byte[] byteArray2 = Base64.getDecoder().decode(b64);
        List<Boolean> list2 = Bits.asStore(byteArray2).asList();
        System.out.println(code.decode(list2));
        System.out.println(code.decode(result));
    }

    private List<Boolean> encoded(
            HuffmanCode<Integer, List<Boolean>> code, int n) {
        List<Boolean> c = code.encode(n);
//        System.out.println(c);
//        System.out.println(booleanListAsByteArrayToStirng(c));
        return c;
    }

    private String booleanListAsByteArrayToStirng(List<Boolean> c) {
        return Arrays.toString(Bits.asStore(Utils.fromBitList(c)).toByteArray());
    }

}